package com.xkrs.service.impl;

import com.xkrs.dao.PictureDao;
import com.xkrs.encapsulation.PromptMessageEnum;
import com.xkrs.model.entity.PictureEntity;
import com.xkrs.model.qo.PictureQo;
import com.xkrs.service.PictureService;
import com.xkrs.util.ExcelUploadUtil;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.stereotype.Service;
import org.springframework.web.multipart.MultipartFile;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.Locale;

import static com.xkrs.encapsulation.OutputEncapsulation.outputEncapsulationObject;

@Service
public class PictureServiceImpl implements PictureService {

    @Resource
    private PictureDao pictureDao;

    @Override
    public String insertPicture(PictureQo pictureQo, MultipartFile pictureFile) throws IOException {
        Locale locale = LocaleContextHolder.getLocale();
        String lotNo = pictureQo.getLotNo();
        String machineNo = pictureQo.getMachineNo();
        String materialNo = pictureQo.getMaterialNo();
        String modelNo = pictureQo.getModelNo();
        String partNo = pictureQo.getPartNo();
        PictureEntity pictureEntity = pictureDao.selectPicture(lotNo, machineNo, materialNo, modelNo, partNo).get();
        if (pictureEntity != null) {
            return outputEncapsulationObject(PromptMessageEnum.DATA_EXIT, "请勿重复添加!", locale);
        }
        String file = ExcelUploadUtil.memoryFile(pictureFile);
        PictureEntity pictureEntity1 = new PictureEntity();
        pictureEntity1.setLotNo(lotNo);
        pictureEntity1.setMachineNo(machineNo);
        pictureEntity1.setMaterialNo(materialNo);
        pictureEntity1.setModelNo(modelNo);
        pictureEntity1.setPartNo(partNo);
        pictureEntity1.setPicturePath(file);
        pictureDao.save(pictureEntity1);
        return outputEncapsulationObject(PromptMessageEnum.SUCCESS, "添加成功！", locale);
    }
}
